Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.tinytree
Class TinyTreeWalker

    java.lang.Object
      net.sf.saxon.tinytree.TinyTreeWalker

All Implemented Interfaces:
  javax.xml.transform.SourceLocator, PullProvider

    public class TinyTreeWalker

extends java.lang.Object
implements PullProvider, javax.xml.transform.SourceLocator

This implementation of the Saxon pull interface starts from a document, element, text, comment, or processing-instruction node in a TinyTree, and returns the events corresponding to that node and its descendants (including their attributes and namespaces). The class performs the same function as the general-purpose `TreeWalker` class, but is specialized to exploit the TinyTree data structure: in particular, it never materializes any Node objects.

Field Summary

Fields inherited from interface net.sf.saxon.pull.PullProvider
`ATOMIC_VALUE, ATTRIBUTE, COMMENT, END_DOCUMENT, END_ELEMENT, END_OF_INPUT, NAMESPACE, PROCESSING_INSTRUCTION, START_DOCUMENT, START_ELEMENT, START_OF_INPUT, TEXT`

Constructor Summary
`TinyTreeWalker(TinyNodeImpl startNode)` Create a TinyTreeWalker to return events associated with a tree or subtree

Method Summary
`void` | `close()` Close the event reader.
`int` | `current()` Get the event most recently returned by next(), or by other calls that change the position, for example getStringValue() and skipToMatchingEnd().
`AtomicValue` | `getAtomicValue()` Get an atomic value.
`AttributeCollection` | `getAttributes()` Get the attributes associated with the current element.
`int` | `getColumnNumber()` Return the character position where the current document event ends.
`int` | `getFingerprint()` Get the fingerprint of the name of the element.
`int` | `getLineNumber()` Return the line number where the current document event ends.
`int` | `getNameCode()` Get the nameCode identifying the name of the current node.
`NamePool` | `getNamePool()` Get the namePool used to lookup all name codes and namespace codes
`NamespaceDeclarations` | `getNamespaceDeclarations()` Get the namespace declarations associated with the current element.
`PipelineConfiguration` | `getPipelineConfiguration()` Get configuration information.
`java.lang.String` | `getPublicId()` Return the public identifier for the current document event.
`javax.xml.transform.SourceLocator` | `getSourceLocator()` Get the location of the current event.
`java.lang.CharSequence` | `getStringValue()` Get the string value of the current attribute, text node, processing-instruction, or atomic value.
`java.lang.String` | `getSystemId()` Return the system identifier for the current document event.
`int` | `getTypeAnnotation()` Get the type annotation of the current attribute or element node, or atomic value.
`java.util.List` | `getUnparsedEntities()` Get a list of unparsed entities.
`static void` | `main(java.lang.String[] args)`
`int` | `next()` Get the next event
`void` | `setPipelineConfiguration(PipelineConfiguration pipe)` Set configuration information.
`int` | `skipToMatchingEnd()` Skip the current subtree.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### TinyTreeWalker

    public TinyTreeWalker(TinyNodeImpl startNode)

  Create a TinyTreeWalker to return events associated with a tree or subtree

  Parameters:
    `startNode` - the root of the tree or subtree. Must be a document, element, text, comment, or processing-instruction node.
  Throws:
    `java.lang.IllegalArgumentException` - if the start node is an attribute or namespace node.

Method Detail

### setPipelineConfiguration

    public void setPipelineConfiguration(PipelineConfiguration pipe)

  Set configuration information. This must only be called before any events have been read.

  Specified by:
    `setPipelineConfiguration` in interface `PullProvider`
  Parameters:
    `pipe` - the pipeline configuration

### getPipelineConfiguration

    public PipelineConfiguration getPipelineConfiguration()

  Get configuration information.

  Specified by:
    `getPipelineConfiguration` in interface `PullProvider`
  Returns:
    the pipeline configuration

### next

    public int next()
             throws XPathException

  Get the next event

  Specified by:
    `next` in interface `PullProvider`
  Returns:
    an integer code indicating the type of event. The code `PullProvider.END_OF_INPUT` is returned if there are no more events to return.
  Throws:
    `XPathException`

### current

    public int current()

  Get the event most recently returned by next(), or by other calls that change the position, for example getStringValue() and skipToMatchingEnd(). This method does not change the position of the PullProvider.

  Specified by:
    `current` in interface `PullProvider`
  Returns:
    the current event

### getAttributes

    public AttributeCollection getAttributes()
                                      throws XPathException

  Get the attributes associated with the current element. This method must be called only after a START_ELEMENT event has been notified. The contents of the returned AttributeCollection are guaranteed to remain unchanged until the next START_ELEMENT event, but may be modified thereafter. The object should not be modified by the client.

  Attributes may be read before or after reading the namespaces of an element, but must not be read after the first child node has been read, or after calling one of the methods skipToEnd(), getStringValue(), or getTypedValue().

  Specified by:
    `getAttributes` in interface `PullProvider`
  Returns:
    an AttributeCollection representing the attributes of the element that has just been notified.
  Throws:
    `XPathException`

### getNamespaceDeclarations

    public NamespaceDeclarations getNamespaceDeclarations()
                                                   throws XPathException

  Get the namespace declarations associated with the current element. This method must be called only after a START_ELEMENT event has been notified. In the case of a top-level START_ELEMENT event (that is, an element that either has no parent node, or whose parent is not included in the sequence being read), the NamespaceDeclarations object returned will contain a namespace declaration for each namespace that is in-scope for this element node. In the case of a non-top-level element, the NamespaceDeclarations will contain a set of namespace declarations and undeclarations, representing the differences between this element and its parent.

  It is permissible for this method to return namespace declarations that are redundant.

  The NamespaceDeclarations object is guaranteed to remain unchanged until the next START_ELEMENT event, but may then be overwritten. The object should not be modified by the client.

  Namespaces may be read before or after reading the attributes of an element, but must not be read after the first child node has been read, or after calling one of the methods skipToEnd(), getStringValue(), or getTypedValue().

  *

  Specified by:
    `getNamespaceDeclarations` in interface `PullProvider`
  Returns:
    the namespace declarations associated with the current START_ELEMENT event.
  Throws:
    `XPathException`

### skipToMatchingEnd

    public int skipToMatchingEnd()
                          throws XPathException

  Skip the current subtree. This method may be called only immediately after a START_DOCUMENT or START_ELEMENT event. This call returns the matching END_DOCUMENT or END_ELEMENT event; the next call on next() will return the event following the END_DOCUMENT or END_ELEMENT.

  Specified by:
    `skipToMatchingEnd` in interface `PullProvider`
  Returns:
    the matching END_DOCUMENT or END_ELEMENT event
  Throws:
    `XPathException`

### close

    public void close()

  Close the event reader. This indicates that no further events are required. It is not necessary to close an event reader after `PullProvider.END_OF_INPUT` has been reported, but it is recommended to close it if reading terminates prematurely. Once an event reader has been closed, the effect of further calls on next() is undefined.

  Specified by:
    `close` in interface `PullProvider`

### getNamePool

    public NamePool getNamePool()

  Get the namePool used to lookup all name codes and namespace codes

  Returns:
    the namePool

### getNameCode

    public int getNameCode()

  Get the nameCode identifying the name of the current node. This method can be used after the `PullProvider.START_ELEMENT`, `PullProvider.PROCESSING_INSTRUCTION`, `PullProvider.ATTRIBUTE`, or `PullProvider.NAMESPACE` events. With some PullProvider implementations, including this one, it can also be used after `PullProvider.END_ELEMENT`. If called at other times, the result is undefined and may result in an IllegalStateException. If called when the current node is an unnamed namespace node (a node representing the default namespace) the returned value is -1.

  Specified by:
    `getNameCode` in interface `PullProvider`
  Returns:
    the nameCode. The nameCode can be used to obtain the prefix, local name, and namespace URI from the name pool.

### getFingerprint

    public int getFingerprint()

  Get the fingerprint of the name of the element. This is similar to the nameCode, except that it does not contain any information about the prefix: so two elements with the same fingerprint have the same name, excluding prefix. This method can be used after the `PullProvider.START_ELEMENT`, `PullProvider.END_ELEMENT`, `PullProvider.PROCESSING_INSTRUCTION`, `PullProvider.ATTRIBUTE`, or `PullProvider.NAMESPACE` events. If called at other times, the result is undefined and may result in an IllegalStateException. If called when the current node is an unnamed namespace node (a node representing the default namespace) the returned value is -1.

  Specified by:
    `getFingerprint` in interface `PullProvider`
  Returns:
    the fingerprint. The fingerprint can be used to obtain the local name and namespace URI from the name pool.

### getStringValue

    public java.lang.CharSequence getStringValue()
                                          throws XPathException

  Get the string value of the current attribute, text node, processing-instruction, or atomic value. This method cannot be used to obtain the string value of an element, or of a namespace node. If the most recent event was anything other than `PullProvider.START_ELEMENT`, `PullProvider.TEXT`, `PullProvider.PROCESSING_INSTRUCTION`, or `PullProvider.ATOMIC_VALUE`, the result is undefined.

  Specified by:
    `getStringValue` in interface `PullProvider`
  Returns:
    the String Value of the node in question, defined according to the rules in the XPath data model.
  Throws:
    `XPathException`

### getAtomicValue

    public AtomicValue getAtomicValue()

  Get an atomic value. This call may be used only when the last event reported was ATOMIC_VALUE. This indicates that the PullProvider is reading a sequence that contains a free-standing atomic value; it is never used when reading the content of a node.

  Specified by:
    `getAtomicValue` in interface `PullProvider`
  Returns:
    the atomic value

### getTypeAnnotation

    public int getTypeAnnotation()

  Get the type annotation of the current attribute or element node, or atomic value. The result of this method is undefined unless the most recent event was START_ELEMENT, START_CONTENT, ATTRIBUTE, or ATOMIC_VALUE.

  Specified by:
    `getTypeAnnotation` in interface `PullProvider`
  Returns:
    the type code. This code is the fingerprint of a type name, which may be resolved to a `SchemaType` by access to the Configuration.

### getSourceLocator

    public javax.xml.transform.SourceLocator getSourceLocator()

  Get the location of the current event. For an event stream representing a real document, the location information should identify the location in the lexical XML source. For a constructed document, it should identify the location in the query or stylesheet that caused the node to be created. A value of null can be returned if no location information is available.

  Specified by:
    `getSourceLocator` in interface `PullProvider`
  Returns:
    the SourceLocator giving the location of the current event, or null if no location information is available

### getPublicId

    public java.lang.String getPublicId()

  Return the public identifier for the current document event.

  The return value is the public identifier of the document entity or of the external parsed entity in which the markup that triggered the event appears.

  Specified by:
    `getPublicId` in interface `javax.xml.transform.SourceLocator`
  Returns:
    A string containing the public identifier, or null if none is available.
  See Also:
    `getSystemId()`

### getSystemId

    public java.lang.String getSystemId()

  Return the system identifier for the current document event.

  The return value is the system identifier of the document entity or of the external parsed entity in which the markup that triggered the event appears.

  If the system identifier is a URL, the parser must resolve it fully before passing it to the application.

  Specified by:
    `getSystemId` in interface `javax.xml.transform.SourceLocator`
  Returns:
    A string containing the system identifier, or null if none is available.
  See Also:
    `getPublicId()`

### getLineNumber

    public int getLineNumber()

  Return the line number where the current document event ends.

  Warning: The return value from the method is intended only as an approximation for the sake of error reporting; it is not intended to provide sufficient information to edit the character content of the original XML document.

  The return value is an approximation of the line number in the document entity or external parsed entity where the markup that triggered the event appears.

  Specified by:
    `getLineNumber` in interface `javax.xml.transform.SourceLocator`
  Returns:
    The line number, or -1 if none is available.
  See Also:
    `getColumnNumber()`

### getColumnNumber

    public int getColumnNumber()

  Return the character position where the current document event ends.

  Warning: The return value from the method is intended only as an approximation for the sake of error reporting; it is not intended to provide sufficient information to edit the character content of the original XML document.

  The return value is an approximation of the column number in the document entity or external parsed entity where the markup that triggered the event appears.

  Specified by:
    `getColumnNumber` in interface `javax.xml.transform.SourceLocator`
  Returns:
    The column number, or -1 if none is available.
  See Also:
    `getLineNumber()`

### getUnparsedEntities

    public java.util.List getUnparsedEntities()

  Get a list of unparsed entities.

  Specified by:
    `getUnparsedEntities` in interface `PullProvider`
  Returns:
    a list of unparsed entities, or null if the information is not available, or an empty list if there are no unparsed entities.

### main

    public static void main(java.lang.String[] args)
                     throws java.lang.Exception

  Throws:
    `java.lang.Exception`

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) Saxonica Limited. All rights reserved.